K = require('kcore')

K.Error.throwExceptionIfParameterNotSet(K.AuthProvider, 'K.AuthProvider')

class K.AuthProviderAnonymous extends K.AuthProvider
  @NICK_MAX_LEN         = 100
  @IS_OK_AS_NICK_REGEXP = new RegExp('^[a-zA-Z0-9_]+$', '')

  constructor: (kRequest) ->
    super(kRequest)

  getAuthenticatedUserModelByAuthId: (authId, done) ->
    @isAuthenticatedIdentity authId, (err, isAuth) =>
      if err?
        # Error while checking is user authorized.
        done(err)

      else if authId
        # User authorized. Get his model.
        @app.getModel('user.anonymous.' + authId, done)

      else
        # User not authorized.
        done(K.Error.createNotAuthenticatedByProviderError(authId, 'anonymous'))

  isAuthenticatedIdentity: (authId, done) ->
    done(null, @_isOkAsNick(authId))

  getAuthenticatedIdentities: (done) ->
    done(null, ['default'])

  _isOkAsNick: (nick) ->
    return nick? and
    nick.length < K.AuthProviderAnonymous.NICK_MAX_LEN and
    K.AuthProviderAnonymous.IS_OK_AS_NICK_REGEXP.test(nick)
