K  = require('kcore')
fs = require('fs')

class K.ServerContentResponse
  constructor: (@kRequest) ->
    @app    = @kRequest.getApp()
    @pageId = null

  # The GET-by-kRequest finds the content for given HTTP-GET-request.
  # It's expected to be called when client requests the download
  # of the content (like HTML file) according to URL
  getByKRequest: (done) ->
    route = @app.getRouter().routeByPath(@kRequest.getExpressRequest().originalUrl)
    @getByRoute(route, done)

  # The GET-by-linkin finds the content by the linkin.
  # It's expected to be called when client requests the download of content
  # by something else than typical HTTP-GET-request call, for example: by a JSON action.
  getByLinkin: (linkin, done) ->
    route = @app.getRouter().routeByLinkin(linkin)
    @getByRoute(route, done)

  # To be overriden by the "real" ServerContent implementation
  getByRoute: (@route, done) ->
    rv = @fetchTemplate(@route)
    done(null, rv)

  fetchTemplate: (route) ->
    return {route:route, pageId: @pageId}

  fetchError: (route, done) ->
    rv = @fetchTemplate(route)
    rv.viewType    = 'basic'
    rv.isError     = 1
    rv.contentMain = 'Document not found...'
    done(null, rv)

  loadDataFromCoffee: (path, done) ->
    @app.getFileManager().loadDataFromCoffee(path, done)

  loadDataFromJson: (path, done) ->
    @app.getFileManager().loadDataFromJson path, true, done
