K = require('kcore')
requestStats = require('request-stats')

class K.ServerStatsCollector
  constructor: () ->
    @postCnt           = 0
    @getCnt            = 0
    @jsonOkCnt         = 0
    @jsonErrorCnt      = 0
    @openWebsocketsCnt = 0

  reportHit: (method) ->
    switch(method)
      when 'GET'
        @getCnt++
      when 'POST'
        @postCnt++

  reportJsonAction: (actionResult) ->
    if actionResult?.status is 'ok'
      @jsonOkCnt++
    else
      @jsonErrorCnt++

  reportWebsocketOpen: () ->
    @openWebsocketsCnt++

  reportWebsocketClose: () ->
    @openWebsocketsCnt--

  getPostHitsCounter: () ->
    return @postCnt

  getGetHitsCounter: () ->
    return @getCnt

  getJsonOkCounter: () ->
    return @jsonOkCnt

  getJsonErrorCounter: () ->
    return @jsonErrorCnt

  getOpenWebsocketsCounter: () ->
    return @openWebsocketsCnt

  @setRequestStatsHandler = (httpServer, serverStats) ->
    requestStats httpServer, (stats) =>
      responseStats = {
        ok: stats.ok
        timeElapsedMs: stats.time
        bytesReceived: stats.req.bytes
        bytesSent: stats.res.bytes
        status: stats.res.status
      }
      stats.req.raw.log.logTime {eventType:'responseStats', stats: responseStats}
      serverStats.reportHit(stats.req.method)
