let K = require('kcore')

class ServerWorkspace
{
  constructor(name, config)
  {
    this.name      = name
    this.serverLog = config.serverLog
    this.debugMode = (typeof config.debugMode != 'undefined') && (config.debugMode)

    this.lockManager    = new K.LockManager(this)
    this.fileManager    = new K.FileManager(this)
    this.sessionManager = null
    this.eventServer    = new K.EventServer(this)
  }

  getLog(app)
  {
    return this.serverLog
  }

  getLockManager(app)
  {
    return this.lockManager
  }

  getFileManager(app)
  {
    return this.fileManager
  }

  getSessionManager(app)
  {
    return this.sessionManager
  }

  getEventServer(app)
  {
    return this.eventServer
  }

  isDebugMode()
  {
    return this.debugMode
  }
}

//
// Export classes.
//

K.ServerWorkspace = ServerWorkspace
